package util.network.epidemic.replay

import util.network.epidemic.EpidemicPacket
import util.network.epidemic.EpidemicPacketPrototype
import util.network.simulator.Address

class ReplayPacket<T>(
    senderAddress: Address,
    receiverAddress: Address,
    payload: T,
    type: Type,
    val isReplay: Boolean
) : EpidemicPacket<T>(senderAddress, receiverAddress, payload, type)

class ReplayPacketPrototype<T> (
    senderAddress: Address,
    payload: T,
    type: EpidemicPacket.Type,
    val isReplay: Boolean
) : EpidemicPacketPrototype<T>(senderAddress, payload, type) {
    override fun makePacket(receiverAddress: Address): EpidemicPacket<T> {
        return ReplayPacket(
            senderAddress,
            receiverAddress,
            payload,
            type,
            isReplay
        )
    }
}